part of fishbone;

class Application {
  html.Element container;

  var controllers = {};
  var routes = {};
  var params = {};
  String currentPath;

  Application(this.container) {

    // handle routes
    // TODO BUG handle if directly input an url with hash
    html.window.history.replaceState('', null, "#/");
    html.window.onHashChange.listen((e){ navigated(); });
  }

  void navigate(String path){
    if (path == null) { path = ''; }
    if (path == currentPath) { return; }

    html.window.history.pushState(path, null, "#/$path");
    navigated();
  }

  void navigated(){
    // validate
    if (html.window.location.hash == '') { return; }
    if (!html.window.location.hash.startsWith('#/')) { return; }
    String path = html.window.location.hash.replaceFirst('#/', '');
    if (path == currentPath) { return; }

    print(routes[path]);
    // get params
    // match routes
    var controller = controllers[routes[path].split('#').first];
    print(controller);
    // distribute to controllers

    currentPath = path;
  }
}
